<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      /**
       * Есть несколько функций по работе с складом. Отрефакторить код таким образом,
       * чтобы можно было
       * 1) Создавать несколько складов, конфигурируя при создании
       * название, вместительность и продукты (объект, где ключи - это названия продуктов,
       * а значения - их количество)
       * 2) У каждого склада были одинаковые методы, которые перечислены в коде
       * 3) Дописать метод склада, который будет возвращать количество конкретного
       * продукта на этом складе
       */
      function getProductQuantity(products, productName) {
        let quantity = products[productName];
        // если значение свойства undefined, нет такого
        if (typeof quantity === "undefined") {
          console.error("Product not found"); // даем ошибку, возвращаем 0
          return 0;
        } else {
          // возвращаем количество
          return quantity;
        }
      }

      function getMaxQuantity(products) {
        let max = 0;
        let maxProductName;

        for (const product in products) {
          if (products[product] > max) {
            max = products[product];
            maxProductName = product;
          }
        }
        return maxProductName;
      }

      // функция для получения общего количества конкретного продукта на всех складах
      function getTotalQuantity(productTitle, warehousesArr) {
        let sum = warehousesArr.reduce((acc, warehouse) => {
          return (acc += warehouse.getProductQuantity(productTitle));
        }, 0);

        return sum;
      }
    </script>
  </body>
</html>
